require 'dohweb/group_params'

module DohWeb

class Test_group_params < DohTest::TestGroup
  include DohWeb

  def before_each
    @exd = {}
    @inp = {}
  end

  def verify
    assert_equal(@exd, group_params(:some, @inp))
  end

  def test_stuff
    @exd['blah'] = @inp['some_blah'] = :yes
    verify

    @exd['blee'] = @inp['some_blee'] = 'bloo'
    verify

    @inp['other'] = :diff
    verify

    @exd['thing'] = @inp['some_thing'] = 1
    @inp['another'] = 1
    verify

    @exd['multi'] = {'hey' => :yes, 'hi' => :no}.to_s
    @inp['some_multi__hey'] = :yes
    @inp['some_multi__hi'] = :no
    verify

    @exd['long'] = {'howdy' => 'b', 'there' => 'e', 'george' => 'goo', 'bob' => 'i'}.to_s
    @inp['some_long__howdy'] = 'b'
    @inp['some_long__there'] = 'e'
    @inp['some_long__george'] = 'goo'
    @inp['some_long__bob'] = 'i'
    verify

    @exd['bday'] = Date.new(2012, 3, 21)
    @inp['some_bday__year'] = '2012'
    @inp['some_bday__month'] = '3'
    @inp['some_bday__day'] = '21'
    verify

    @exd['when'] = DateTime.new(2012, 3, 21, 5, 0, 0)
    @inp['some_when__year'] = '2012'
    @inp['some_when__month'] = '3'
    @inp['some_when__day'] = '21'
    @inp['some_when__hour'] = '5'
    verify
  end
end

end
